unit Frmunin;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, DdeMan, Ver, IniFiles;
type
  TfrmUnInst = class(TForm)
    lblByLine: TLabel;
    btnExit: TButton;
    lblAppNames: TLabel;
    DdeClient: TDdeClientConv;
    imgBackGround: TImage;
    lblAppName: TLabel;
    procedure FormResize(Sender: TObject);
    procedure btnExitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
    IniFile: TIniFile;
    procedure UnInstall(Dir, Files, Items, Group: boolean);
    procedure DeleteProgGroup(GroupName: string);
    procedure DeleteProgItem(GroupName, ItemName: string);

  end;

var { Global varibles }
  frmUnInst: TfrmUnInst;
  WinVer: String;
  DestPath, SourcePath: String;
  DestDrive, SourceDrive : String;
  iError, iInstalled, iSize: Integer;
  bError: Boolean;
  sIniFile, IniValue, IniPrefix: string;
  Appname, ByLine: string;

implementation
{$R *.DFM}
{$I-}

uses
  frmSlect, frmWelcm, frmchapp;

procedure TfrmUnInst.FormResize(Sender: TObject);
begin
  if frmUnInst.ClientWidth<552 then frmUnInst.ClientWidth :=552;
  btnExit.top:= (frmUnInst.ClientHeight-33);
  btnExit.left:= (frmUnInst.ClientWidth-97);
end;

procedure TfrmUnInst.btnExitClick(Sender: TObject);
begin
  Halt;
end;

procedure TfrmUnInst.FormCreate(Sender: TObject);
var
  WinVersion: LongInt;
begin
  if frmUnInst.ClientWidth<552 then frmUnInst.ClientWidth :=552;
  frmUnInst.WindowState := wsMaximized;

  btnExit.top:= (frmUnInst.ClientHeight-33);
  btnExit.left:= (frmUnInst.ClientWidth-97);

  {Get windows version etc.}
  WinVersion := GetVersion and $FFFF;
  WinVer:=Concat((IntToStr(Winversion mod 256)),'.',(IntToStr(Winversion div 256)));

  sIniFile := Paramstr(1);
  IniPrefix := Paramstr(2);
  if sIniFile = '' then
  begin
    frmChooseApp.ShowModal;
  end;
  IniFile:=TIniFile.Create(sIniFile);

  { Find out some stuff from the install log }
  AppName:=IniFile.ReadString(IniPrefix+'System', 'AppName', 'Not a valid instalation log');

  lblAppName.caption := AppName;
  lblAppNames.caption := AppName;
  frmUnInst.caption := AppName + ' Uninstaller';

  { Find out some stuff from the install log }
  ByLine:=IniFile.ReadString(IniPrefix+'System', 'ByLine', 'Copyright 1996 Rowland Shaw');

  lblByLine.caption := ByLine;

  if AppName = 'Not a valid instalation log' then
  begin
    MessageDlg('The installation log specified does not exist or is not of the correct format.'
      ,mtError, [mbAbort],0);
    Application.Terminate;
  end;
  { Show first 'dialog' }
  frmWelcome.show;
end;

procedure TfrmUnInst.UnInstall(Dir, Files, Items, Group: boolean);
var
  iFiles, iItems, iCounter: Integer;
  sTemp, sGroup: string;
  pString: array [0..255] of char;
begin
  { start uninstalling stuff }
  if files then
  begin
    { get number of files }
    { Find out from the install log }
    iFiles := Inifile.ReadInteger(IniPrefix+'System', 'NumFiles', 0);

    { Delete the files }
    For iCounter := 1 to (iFiles-1) do
    begin
      { Find out some stuff from the install log }
      IniValue := IniFile.ReadString(IniPrefix+'File List', 'File'+IntToStr(iCounter), 'None');
      if not (IniValue = 'None') then
        DeleteFile(IniValue);
    end;
  { Tell the install log about it }
  IniFile.WriteInteger(IniPrefix+'System', 'NumFiles', 0);
  end; { files done }

  if items then
  begin
    { get number of program items }
    { Find out from the install log }
    iItems := IniFile.ReadInteger(IniPrefix+'System', 'NumProgItems', 0);

    { find out the the program group }
    { Find out some stuff from the install log }
    IniValue:=IniFile.ReadString(IniPrefix+'System', 'CreateGroup', 'None');
    if IniValue = 'None' then
      IniValue:=IniFile.ReadString(IniPrefix+'System', 'ProgGroup', 'None');
    if not (IniValue = 'None') then sGroup := IniValue;

    For iCounter := 1 to (iItems) do
    begin
      { Find out some stuff from the install log }
      { Find out some stuff from the install log }
      IniValue := IniFile.ReadString(IniPrefix+'Program Items', 'Item'+IntToStr(iCounter), 'None');
      if not (IniValue = 'None') then
      begin
        sTemp := IniValue;
        DeleteProgItem(sGroup, sTemp);
      end;
    end;
  { Tell the install log about it }
  IniFile.WriteInteger(IniPrefix+'System', 'NumProgItems', 0);
  end; { Program items }

  if group then
  begin
    { Delete the Program Group }
    { Find out some stuff from the install log }
    IniValue:=IniFile.ReadString(IniPrefix+'System', 'CreateGroup', 'None');
    if IniValue = 'None' then
      IniValue:=IniFile.ReadString(IniPrefix+'System', 'ProgGroup', 'None');
    if not (IniValue = 'None') then
    begin
      sGroup := IniValue;
      DeleteProgGroup(sGroup);
      { Tell the install log about it }
      IniFile.WriteString(IniPrefix+'System', 'CreateGroup', 'None');
    end;
  end; { program group }

  if dir then
  begin
    { Delete the Directory }
    { Find out some stuff from the install log }
    sTemp:=IniFile.ReadString(IniPrefix+'System', 'CreateDirectory', 'None');
    if not (sTemp = 'None') then
    begin
      RmDir(sTemp);
      if IOResult = 0 then
      begin
        { Tell the install log about it }
        IniFile.WriteString(IniPrefix+'System', 'CreateDirectory', 'None');
      end;
    end;
  end; { dir }

  if (dir and files and group and (UpperCase(Paramstr(1)) <> 'RESETUP.INI')) then
  begin
    { finally delete the install log }
    GetWindowsDirectory(pString, 260);
    sTemp := StrPas(pString) + '\' + Paramstr(1);
    DeleteFile(sTemp);
  end; { removal of install log }

  if (dir and files and group and (UpperCase(Paramstr(1)) = 'RESETUP.INI')) then
  begin
    { finally section from the install log }

  end; { removal of install log }

  { and tell the user it's all gone }
  MessageDlg('All gone I''m afraid!', mtInformation, [mbOK], 0);
  Application.Terminate;
end;

procedure TfrmUnInst.DeleteProgGroup(GroupName: string);
var
  Cmd: array [0..255] of char;
  Macro: string;
begin
  Macro := Format('[DeleteGroup(%s)]', [GroupName]) + #13#10;
  StrPCopy (Cmd, Macro);
  if not DDEClient.ExecuteMacro(Cmd, False) then
    MessageDlg('Unable to delete group.', mtInformation, [mbOK], 0);
end;

procedure TfrmUnInst.DeleteProgItem(GroupName, ItemName: string);
{ Doesn't work! }
var
  Cmd: array [0..255] of char;
  Macro: string;
begin
  Macro := Format('[ShowGroup(%s,1)]', [ItemName]) + #13#10;
  StrPCopy (Cmd, Macro);
  if not DDEClient.ExecuteMacro(Cmd, False) then
    MessageDlg('Unable to delete item. (DDE Failure)', mtInformation, [mbOK], 0);
  Macro := Format('[DeleteItem(%s)]', [ItemName]) + #13#10;
  StrPCopy (Cmd, Macro);
  if not DDEClient.ExecuteMacro(Cmd, False) then
    MessageDlg('Unable to delete item. (DDE Failure)', mtInformation, [mbOK], 0);
end;

end.
